Summary: GNU Compiler Collection
Name: gcc%{_mvl_pkg_suffix}

Version: 3.4.3
Release: 25.0.116.%{_mvl_build_id}
Source0: gcc-%{version}.tar.bz2

%define autoconf_version 2.59
%define automake_version 1.8

License: GPL/LGPL
Group: devel
Buildroot: %{_tmppath}/%{name}-%{_mvl_target_arch}-root
Prefix: %{_mvl_cross_target_dir}
%define _docdir          %{_mvl_cross_target_dir}/%{_mvl_target_doc_dir}
Requires: binutils
Obsoletes: hhl-%{_mvl_target_arch}-gcc
Obsoletes: cpp, hhl-%{_mvl_target_arch}-cpp


%if "%{_mvl_target_arch}" == "ppc_7xx"
%define supports_backcompat yes
%else
%define supports_backcompat no
%endif

Source1: gcc-license.txt

%if "%{supports_backcompat}" == "yes"
Source2: libstdc++.so.5.0.5-%{_mvl_target_arch}
%endif

Source13: gcc-xtensa_linux_be.tar
Source14: gcc-xtensa_linux_le.tar
Patch999: gcc-mips64-cavium-octeon-specific.patch

# These patches are not applied during prep, so treat it specially.
Source8: gcc-3.4.1-x86-em64t-specs.patch
Source9: gcc-ppc64-specs.patch
Source20: gcc-3.3.1-mips64-specs.patch
Source21: gcc-3.3.1-mips64-big-specs.patch
Source22: gcc-3.4-mips64-octeon-specs.patch

%if "%{_mvl_target_cpu}" == "ppc64" || "%{_mvl_target_cpu}" == "x86_64"
%define _objdir objdir%{_mvl_pkg_suffix}
%endif


Patch1:  gcc-contact-montavista.patch
Patch2:  gcc-3.4.3-3.4.4.patch
Patch3:  gcc-3.4.4-3.4.5.patch
Patch4:  gcc-3.4.5-3.4.6.patch
Patch5:  gcc-3.4.2-cslarmbranch.patch
Patch6:  gcc-3.3-libstdc-automake.patch
Patch7:  gcc-3.4-target-nls.patch
Patch8:  gcc-visibility.patch
Patch9:  gcc-3.4-include-poison.patch
Patch10:  gcc-3.3-softfloat.patch
Patch11:  gcc-3.3-ifcvt-test.patch
Patch12:  gcc-3.4-mips_nfp.patch
Patch13:  gcc-3.4-mips_pcrel.patch
Patch14:  gcc-3.4-mips64-nomultilib.patch
Patch15:  gcc-3.4.2.cslarm-arm_be_nfp.patch
Patch16:  gcc-arm-div0-cfi.patch
Patch17:  gcc-3.4-arm-iwmmxt-regsave.patch
Patch18:  gcc-3.4.2.cslarm-interwork-config.patch
Patch19:  gcc-thumb-profile-nest.patch
Patch20:  gcc-3.3.1-thumb-trampoline.patch
Patch21:  gcc-3.4-sh.patch
Patch22:  gcc-sh-no_implicit_fp.patch
Patch23:  gcc-sh-misc.patch
Patch24:  gcc-3.3.1-sh_reload.patch
Patch25:  gcc-3.3-sh_constpool.patch
Patch26:  gcc-sh_mod.patch
Patch27:  gcc-xtensa_with_float.patch
Patch28:  gcc-3.2-compoundlit.patch
Patch29:  gcc-3.4.2.cslarm-intl.patch
Patch30:  gcc-3.4.1-spe-no-64bit.patch
Patch31:  gcc-3.4.1-x86-alt.patch
Patch32:  gcc-builtin_expect.patch
Patch33:  gcc-configure-ld.patch
Patch34:  gcc-arm-tls.patch
Patch35:  gcc-arm-softfp.patch
Patch36:  gcc-arm-eabi-exception-handling.patch
Patch37:  gcc-pack-test-4-failure.patch
Patch38:  gcc-arm-eabi-fini-array.patch
Patch39:  gcc-arm-eabi-big-endian.patch
Patch40:  gcc-mips-tls.patch
Patch41:  gcc-sh3-pcrel.patch
Patch42:  gcc-arm-eabi-xscale-insv-extend.patch
Patch43:  gcc-mips-big-endian-signals.patch
Patch44:  gcc-iwmmxt-wldrw-addrmode.patch
Patch45:  gcc-mips-rpath-link.patch
Patch46:  gcc-mips-atomicity.patch
Patch47:  gcc-arm-profiling-have-frame-pointer.patch
Patch48:  gcc-arm-numa-policy.patch
Patch49:  gcc-3.4.3-bug_10214.patch
Patch50:  gcc-sh-mv-no_implicit_fp.patch
Patch51:  gcc-arm-guard-PLT.patch
Patch52:  gcc-3.4-expand-mult-sanity-check.patch
Patch53:  gcc-ppc64-bispecs.patch
Patch54:  gcc-x86-em64t-lib64.patch
Patch55:  gcc-x86-sse.patch
Patch56:  gcc-ppc_440ep-errata42.patch
Patch57:  gcc-nptl_option.patch
Patch58:  gcc-3.4.3-structure_layout.patch
Patch59:  gcc-3.4.3-unswitch_single_loop.patch
Patch60:  gcc-arm-array-decl-alignment.patch
Patch61:  gcc-3.4.3-ppc9xx-reload-fp-constants.patch
Patch62:  gcc-3.4.3-iwithsysroot.patch
Patch63:  gcc-3.4-c-common.patch
Patch64:  gcc-install-libgcc.patch
Patch65:  gcc-mips64-signal-unwind.patch
Patch66:  gcc-mips64-debug-info.patch
Patch67:  gcc-thumb-preserve-arm-fp.patch
Patch68:  gcc-3.4.3-pipe_option.patch
Patch69:  gcc-3.4.3-arm_thumb_eabicomplaint.patch
Patch70:  gcc-inheritedbinding.patch
Patch71:  gcc-3.4.3-gxx-include-dir.patch
Patch72:  gcc-RTABI_functions.patch
Patch73:  gcc-uclibc-conf.patch
Patch74:  gcc-uclibc-locale.patch
Patch75:  gcc-arm-disable-extra-multilib.patch
Patch76:  gcc-3.4-sh-dead_or_predictable.patch
Patch77:  gcc-3.4-nested_array_constructors.patch
Patch78:  gcc-arm-allow-pre-indexed-addressing.patch
Patch79:  gcc-arm-copy-TLS-base-to-pseudo.patch
Patch80:  gcc-3.4.3-soft_float_DImode.patch
Patch81:  gcc-xtensa-new-directive.patch
Patch82:  gcc-xtensa-noreorder-blks.patch
Patch83:  gcc-sh4_reload1.patch
Patch84:  gcc-3.4.3-arm-target-options.patch
Patch85:  gcc-3.4-x86-i386sse.patch
Patch86:  gcc-objdump-and-nm-for-target.patch
Patch87:  gcc-spe-e500-support.patch
Patch88:  gcc-3.4.3-c-typecheck.patch
Patch89:  gcc-uclibc-eabi.patch
Patch90:  gcc-3.4.3-cp_typecheck.patch
Patch91:  gcc-3.4-arm_EABI_div-without-mod.patch
Patch92:  gcc-3.4.3-arm-hide-vfp-regs-for-simode.patch
Patch93:  gcc-arm-symbol_ref_register.patch
Patch94:  gcc-subreg_imode.patch
Patch95:  gcc-expr_VOIDmode.patch
Patch96:  gcc-thumb-syscache-flush.patch
Patch97:  gcc-arm-libgcc-interworking.patch
Patch98:  gcc-arm_mabi_gnu.patch
Patch99:  gcc-arm-vfp-assume-smaller-offset-range.patch
Patch100:  gcc-uclibc-eabi-conf.patch
Patch101:  gcc-3.4-legitimize_reload_address.patch
Patch102:  gcc-gcse-incorrect-pseudo-reg-replacement.patch
Patch103:  gcc-3.4-arm-reject-incompatible-float-abi-commadline-args.patch
Patch104:  gcc-uclibc-libstd++-index-marco.patch
Patch105:  gcc-arm-libgcc-div-functions-interworking.patch
Patch106:  gcc-thumb-PIC-use-pc-rel-addressing.patch
Patch107:  gcc-arm-vfp-fmrrd.patch
Patch108:  gcc-mips-extendsidi2-tie.patch
Patch109:  gcc-mips64-cavium-octeon.patch
Patch110:  gcc-arm-use-gen-int-mode.patch
Patch111:  gcc-profile-thunk-in-wrong-group.patch
Patch112:  gcc-uclibc-USE_PT_GNU_EH_FRAME.patch
Patch113:  gcc-3.4.3-optabs-compare.patch
Patch114:  gcc-mips-vr4130.patch
Patch115:  gcc-xtensa-comdat.patch
Patch116:  gcc-purge-builtin-constants.patch
Patch117:  gcc-3.4-gcov-cross-profiling.patch


%description
This is the GNU C compiler, a fairly portable optimizing compiler which
supports multiple languages.  This package includes support for C.  It also
includes the GNU C preprocessor.

# libgcc1
%package -n libgcc1%{_mvl_pkg_suffix}
Summary: The GNU GCC support library
Group: devel
Obsoletes: hhl-%{_mvl_target_arch}-libgcc1%{_mvl_pkg_suffix}

%description -n libgcc1%{_mvl_pkg_suffix}
This package contains a required runtime library for all programs
built with the GNU compiler.

# libstdc++6
%package -n libstdc++6%{_mvl_pkg_suffix}
Summary: The GNU stdc++ library
Group: devel
Obsoletes: hhl-%{_mvl_target_arch}-libstdc++6%{_mvl_pkg_suffix}

%description -n libstdc++6%{_mvl_pkg_suffix}
This package contains an additional runtime library for C++ programs
built with the GNU compiler.

# libstdc++6-dev
%package -n libstdc++6-dev%{_mvl_pkg_suffix}
Summary: The GNU stdc++ library (development files)
Group: devel
Requires: g++ = %{version}
Obsoletes: hhl-%{_mvl_target_arch}-libstdc++6-dev%{_mvl_pkg_suffix}

%description -n libstdc++6-dev%{_mvl_pkg_suffix}
This package contains the headers and static library files necessary for
building C++ programs which use libstdc++.


%if "%{supports_backcompat}" == "yes"

# compat-libstdc++5
%package -n compat-libstdc++5%{_mvl_pkg_suffix}
Summary: The backward compatibility stdc++ library 
Group: devel

%description -n compat-libstdc++5%{_mvl_pkg_suffix}
This package contains compatibility standard C++ library from gcc-3.3.1. 
This library is provided for backward compatiable.

%endif


# g++
%package -n g++%{_mvl_pkg_suffix}
Summary: The GNU C++ compiler
Group: devel
Requires: gcc = %{version}
Obsoletes: hhl-%{_mvl_target_arch}-g++%{_mvl_pkg_suffix}

%description -n g++%{_mvl_pkg_suffix}
This is the GNU C++ compiler, a fairly portable optimizing compiler for C++.

%if "%{_mvl_pkg_suffix}" == ""
# gcc-doc
%package -n gcc-doc
Summary: Documentation for the GNU compilers (gcc, g++)
Group: devel
Obsoletes: hhl-%{_mvl_target_arch}-gcc-doc
Obsoletes: cpp-doc, hhl-%{_mvl_target_arch}-cpp-doc

%description -n gcc-doc
Documentation for the GNU compilers in info format.

%endif


%define _libgccdir %{_mvl_cross_target_dir}/%{_mvl_target_lib_dir}/gcc/%{_mvl_target_toolconfig}/%{version}

%define _baseconfig %{?_mvl_target_toolconfig_:%{_mvl_target_toolconfig_}}%{!?_mvl_target_toolconfig_:%{_mvl_target_toolconfig}}
%define _baselibdir %{?_mvl_target_lib_:%{_mvl_target_lib_}}%{!?_mvl_target_lib_:%{_mvl_target_lib}}
%define _multilibgccdir %{_mvl_cross_target_dir}/%{_mvl_target_prefix}/%{_baselibdir}/gcc/%{_baseconfig}/%{version}

#####
%prep
#####
%target_check
%target_setup
%setup -n gcc-%{version} -q

# gcc-contact-montavista.patch
%patch1 -p1

# gcc-3.4.3-3.4.4.patch
%patch2 -p1

# gcc-3.4.4-3.4.5.patch
%patch3 -p1

# gcc-3.4.5-3.4.6.patch
%patch4 -p1

# gcc-3.4.2-cslarmbranch.patch
%patch5 -p1

# gcc-3.3-libstdc-automake.patch
%patch6 -p1

# gcc-3.4-target-nls.patch
%patch7 -p1

# gcc-visibility.patch
%patch8 -p1

# gcc-3.4-include-poison.patch
%patch9 -p1

# gcc-3.3-softfloat.patch
%patch10 -p1

# gcc-3.3-ifcvt-test.patch
%patch11 -p1

# gcc-3.4-mips_nfp.patch
%patch12 -p1

# gcc-3.4-mips_pcrel.patch
%patch13 -p1

# gcc-3.4-mips64-nomultilib.patch
%patch14 -p1

# gcc-3.4.2.cslarm-arm_be_nfp.patch
%patch15 -p1

# gcc-arm-div0-cfi.patch
%patch16 -p1

# gcc-3.4-arm-iwmmxt-regsave.patch
%patch17 -p1

# gcc-3.4.2.cslarm-interwork-config.patch
%patch18 -p1

# gcc-thumb-profile-nest.patch
%patch19 -p1

# gcc-3.3.1-thumb-trampoline.patch
%patch20 -p1

# gcc-3.4-sh.patch
%patch21 -p1

# gcc-sh-no_implicit_fp.patch
%patch22 -p1

# gcc-sh-misc.patch
%patch23 -p1

# gcc-3.3.1-sh_reload.patch
%patch24 -p1

# gcc-3.3-sh_constpool.patch
%patch25 -p1

# gcc-sh_mod.patch
%patch26 -p1

# gcc-xtensa_with_float.patch
%patch27 -p1

# gcc-3.2-compoundlit.patch
%patch28 -p1

# gcc-3.4.2.cslarm-intl.patch
%patch29 -p1

# gcc-3.4.1-spe-no-64bit.patch
%patch30 -p1

# gcc-3.4.1-x86-alt.patch
%patch31 -p1

# gcc-builtin_expect.patch
%patch32 -p1

# gcc-configure-ld.patch
%patch33 -p1

# gcc-arm-tls.patch
%patch34 -p1

# gcc-arm-softfp.patch
%patch35 -p1

# gcc-arm-eabi-exception-handling.patch
%patch36 -p1

# gcc-pack-test-4-failure.patch
%patch37 -p1

# gcc-arm-eabi-fini-array.patch
%patch38 -p1

# gcc-arm-eabi-big-endian.patch
%patch39 -p1

# gcc-mips-tls.patch
%patch40 -p1

# gcc-sh3-pcrel.patch
%patch41 -p1

# gcc-arm-eabi-xscale-insv-extend.patch
%patch42 -p1

# gcc-mips-big-endian-signals.patch
%patch43 -p1

# gcc-iwmmxt-wldrw-addrmode.patch
%patch44 -p1

# gcc-mips-rpath-link.patch
%patch45 -p1

# gcc-mips-atomicity.patch
%patch46 -p1

# gcc-arm-profiling-have-frame-pointer.patch
%patch47 -p1

# gcc-arm-numa-policy.patch
%patch48 -p1

# gcc-3.4.3-bug_10214.patch
%patch49 -p1

# gcc-sh-mv-no_implicit_fp.patch
%patch50 -p1

# gcc-arm-guard-PLT.patch
%patch51 -p1

# gcc-3.4-expand-mult-sanity-check.patch
%patch52 -p1

# gcc-ppc64-bispecs.patch
%patch53 -p1

# gcc-x86-em64t-lib64.patch
%patch54 -p1

# gcc-x86-sse.patch
%patch55 -p1

# gcc-ppc_440ep-errata42.patch
%patch56 -p1

# gcc-nptl_option.patch
%patch57 -p1

# gcc-3.4.3-structure_layout.patch
%patch58 -p1

# gcc-3.4.3-unswitch_single_loop.patch
%patch59 -p1

# gcc-arm-array-decl-alignment.patch
%patch60 -p1

# gcc-3.4.3-ppc9xx-reload-fp-constants.patch
%patch61 -p1

# gcc-3.4.3-iwithsysroot.patch
%patch62 -p1

# gcc-3.4-c-common.patch
%patch63 -p1

# gcc-install-libgcc.patch
%patch64 -p1

# gcc-mips64-signal-unwind.patch
%patch65 -p1

# gcc-mips64-debug-info.patch
%patch66 -p1

# gcc-thumb-preserve-arm-fp.patch
%patch67 -p1

# gcc-3.4.3-pipe_option.patch
%patch68 -p1

# gcc-3.4.3-arm_thumb_eabicomplaint.patch
%patch69 -p1

# gcc-inheritedbinding.patch
%patch70 -p1

# gcc-3.4.3-gxx-include-dir.patch
%patch71 -p1

# gcc-RTABI_functions.patch
%patch72 -p1

# gcc-uclibc-conf.patch
%patch73 -p1

# gcc-uclibc-locale.patch
%patch74 -p1

# gcc-arm-disable-extra-multilib.patch
%patch75 -p1

# gcc-3.4-sh-dead_or_predictable.patch
%patch76 -p1

# gcc-3.4-nested_array_constructors.patch
%patch77 -p1

# gcc-arm-allow-pre-indexed-addressing.patch
%patch78 -p1

# gcc-arm-copy-TLS-base-to-pseudo.patch
%patch79 -p1

# gcc-3.4.3-soft_float_DImode.patch
%patch80 -p1

# gcc-xtensa-new-directive.patch
%patch81 -p1

# gcc-xtensa-noreorder-blks.patch
%patch82 -p1

# gcc-sh4_reload1.patch
%patch83 -p1

# gcc-3.4.3-arm-target-options.patch
%patch84 -p1

# gcc-3.4-x86-i386sse.patch
%patch85 -p1

# gcc-objdump-and-nm-for-target.patch
%patch86 -p1

# gcc-spe-e500-support.patch
%patch87 -p1

# gcc-3.4.3-c-typecheck.patch
%patch88 -p1

# gcc-uclibc-eabi.patch
%patch89 -p1

# gcc-3.4.3-cp_typecheck.patch
%patch90 -p1

# gcc-3.4-arm_EABI_div-without-mod.patch
%patch91 -p1

# gcc-3.4.3-arm-hide-vfp-regs-for-simode.patch
%patch92 -p1

# gcc-arm-symbol_ref_register.patch
%patch93 -p1

# gcc-subreg_imode.patch
%patch94 -p1

# gcc-expr_VOIDmode.patch
%patch95 -p1

# gcc-thumb-syscache-flush.patch
%patch96 -p1

# gcc-arm-libgcc-interworking.patch
%patch97 -p1

# gcc-arm_mabi_gnu.patch
%patch98 -p1

# gcc-arm-vfp-assume-smaller-offset-range.patch
%patch99 -p1

# gcc-uclibc-eabi-conf.patch
%patch100 -p1

# gcc-3.4-legitimize_reload_address.patch
%patch101 -p1

# gcc-gcse-incorrect-pseudo-reg-replacement.patch
%patch102 -p1

# gcc-3.4-arm-reject-incompatible-float-abi-commadline-args.patch
%patch103 -p1

# gcc-uclibc-libstd++-index-marco.patch
%patch104 -p1

# gcc-arm-libgcc-div-functions-interworking.patch
%patch105 -p1

# gcc-thumb-PIC-use-pc-rel-addressing.patch
%patch106 -p1

# gcc-arm-vfp-fmrrd.patch
%patch107 -p1

# gcc-mips-extendsidi2-tie.patch
%patch108 -p1

# gcc-mips64-cavium-octeon.patch
%patch109 -p1

# gcc-arm-use-gen-int-mode.patch
%patch110 -p1

# gcc-profile-thunk-in-wrong-group.patch
%patch111 -p1

# gcc-uclibc-USE_PT_GNU_EH_FRAME.patch
%patch112 -p1

# gcc-3.4.3-optabs-compare.patch
%patch113 -p1

# gcc-mips-vr4130.patch
%patch114 -p1

# gcc-xtensa-comdat.patch
%patch115 -p1

# gcc-purge-builtin-constants.patch
%patch116 -p1

# gcc-3.4-gcov-cross-profiling.patch
%patch117 -p1


cp %{SOURCE1} LICENSE

# apply the configuration patches for Tensilica
%if "%{_mvl_target_arch}" == "xtensa_linux_be"
tar -xf %{SOURCE13}
%endif
%if "%{_mvl_target_arch}" == "xtensa_linux_le"
tar -xf %{SOURCE14}
%endif

%if "%{_mvl_target_arch}" == "mips64_octeon_be"
%patch999 -p1
%endif


# we don't need to build texinfo on a current Linux installation
rm -rf texinfo

# delete the GNU message catalogs they will be regenerated during build
rm  -rf gcc/po/*.gmo

# Regenerate configure information to account for changes from patches
AUTOCONF=autoconf-%{autoconf_version}; export AUTOCONF
AUTOHEADER=autoheader-%{autoconf_version}; export AUTOHEADER
ACLOCAL=aclocal-%{automake_version}; export ACLOCAL
AUTOMAKE=automake-%{automake_version}; export AUTOMAKE

# Update configure in the gcc directory
(cd gcc && ${AUTOCONF})
(cd libstdc++-v3 && ${ACLOCAL} && ${AUTOMAKE} && ${AUTOCONF})

# Prevent spurious rebuilds due to brain-dead Makefile dependencies
# (config.in must be newer than cstamp-h.in)
(cd gcc && ${AUTOHEADER})

# Don't update configure in top directory.  It uses autoconf 2.13.
touch configure

# Update configure in intl directory.
(cd intl && ${AUTOCONF})

# Update version number
%define _dt %(date +%%F)
(cd gcc ; sed "/version_string/s#\";\$# (MontaVista %{version}-%{release} %_dt)\";#" \
       < version.c > version.n && mv version.n version.c)
%define NUMA_SUPPORT no
%if "%{_mvl_target_cpu}" == "arm" && "%{_mvl_uclibc}" == "%%%%{_mvl_uclibc}"
	%define NUMA_SUPPORT yes
%endif

######
%build
######
%target_setup


%if "%{_mvl_target_cpu}" == "mips64" || "%{_mvl_target_cpu}" == "ppc64" || "%{_mvl_target_cpu}" == "x86_64"
# (Or for any other multilibbed target, not sure for em64t)
# In order to prevent the GCC makefiles from building multilibs,
# we need to pretend that the host compiler doesn't support them:
# or rather only supports one of them.  The right one.  All we really
# need is the OS multilib directory.
cp `$CC -print-file-name=specs` build.specs
multi_dir=`$CC -print-multi-directory`
%if "_mvl_target_gcc_config" != "--with-cpu=default32"
multi_os_dir=`$CC -print-multi-os-directory`
%else
multi_os_dir=../lib
%endif
# ".:" is special cased in gcc so we need to handle it specially here too.
if test "$multi_dir" = "."; then
  multi_dir_string="$multi_dir ;$multi_dir:$multi_os_dir ;"
else
  multi_dir_string="$multi_dir:$multi_os_dir ;"
fi
# This bit of awk blanks out all of the other multilib related entries in
# the specs file, and replace the list of multilibs with ". ;.:../lib32 ;",
# or "o32:../lib ;", etc.
awk "{ if (/^\*multilib..*:/) { print; getline; print \"\" } else
      {if (/^\*multilib:/) { print; getline; print \"$multi_dir_string\" } else
       print } }" < build.specs > build.specs.tmp
mv -f build.specs.tmp build.specs

CC="$CC -specs=`pwd`/build.specs"
%endif

# This will make GCC configure using the features of the cross assembler,
# rather than the host assembler.  Of course we want the features of the
# target assembler... but this is closer.
# This is necessary for things like .file/.loc to be correctly configured.
export AS=%{_mvl_cross_bin_dir}/%{_mvl_target_toolprefix}as

# Ditto for the cross linker.
# This is necessary for PT_GNU_EH_FRAME support.
export LD=%{_mvl_cross_bin_dir}/%{_mvl_target_toolprefix}ld
# Ditto to run tests using the target NM and OBJDUMP.
export NM=%{_mvl_cross_bin_dir}/%{_mvl_target_toolprefix}nm
export OBJDUMP=%{_mvl_cross_bin_dir}/%{_mvl_target_toolprefix}objdump

export CPP="$CC -E"
export CC_FOR_TARGET=$CC
export AS_FOR_TARGET=$AS
export LD_FOR_TARGET=$LD
export NM_FOR_TARGET=$NM
export OBJDUMP_FOR_TARGET=$OBJDUMP
export RANLIB_FOR_TARGET=$RANLIB
export AR_FOR_TARGET=$AR
export CPP_FOR_TARGET=$CPP
export LD_LIBRARY_PATH=%{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}

# See the comment in libstdc++-v3/src/Makefile.am.  GCC can compile
# C++ files, and this prevents libtool trying to link libstdc++ with
# -lstdc++.  Only a problem in host-x-host builds.
# Note that we must explicitly add -shared-libgcc or libstdc++ won't
# be linked to libgcc_s.so.
export CXX_FOR_TARGET="$CC -shared-libgcc"
export CXX="$CC -shared-libgcc"

# Remove unneeded zlib
rm -rf zlib

%target_tool_configure \
	--target=%{_mvl_target_toolconfig} \
	--program-prefix="" \
	--enable-__cxa_atexit \
	--enable-shared \
	--enable-languages=c,c++ \
	--enable-threads=posix \
	--disable-multilib \
	--with-numa-policy=%{NUMA_SUPPORT} \
%if "%{_mvl_target_fpu}" == "no"
	--with-float=soft \
%else
%if "%{_mvl_target_cpu}" == "arm"
	--with-float=softfp \
%endif
%endif
%if "%{_mvl_target_cpu_type}" == "mips"
%if "%{_mvl_target_cpu_id}" != "%%%%{_mvl_target_cpu_id}"
	--with-arch=%{_mvl_target_cpu_id} \
	--with-tune=%{_mvl_target_cpu_id} \
%if "%{_mvl_target_cpu}" == "mips64"
	--with-abi=n32 \
%else
	--with-abi=32 \
%endif
%endif
%else
%if "%{_mvl_target_cpu}" != "xtensa"
%if "%{_mvl_target_cpu_id}" != "%%%%{_mvl_target_cpu_id}"
	--with-cpu=%{_mvl_target_cpu_id} \
%endif
%endif
%endif
%if "%{_mvl_target_gcc_config}" != "%%%%{_mvl_target_gcc_config}"
	%{_mvl_target_gcc_config} \
%endif
        --libexecdir=%{_mvl_target_lib_dir} \
	2>&1

# Add SYSTEM_HEADER_DIR so that we find <limits.h> from glibc
# FIXME - there should be a better way...
#echo "SYSTEM_HEADER_DIR=%{_mvl_cross_target_dir}%{_mvl_target_include_dir}" \
#	>> gcc/Makefile

%dmake 2>&1

# Fix the specs file to not think we are a cross compiler.
# Do this in build so that tests run out of the build directory will
# find a fixed specs file.

cat gcc/specs | awk \
	'BEGIN {found = 0; done = 0}
	 /^\*cross_compile:$/ {found = 1}
	 /^1$/ {if (found == 1 && done == 0) {print "0"; done = 1} else {print}}
	 !/^1$/ {print}' \
	> gcc/specs.new
mv -f gcc/specs.new gcc/specs

%install
rm -rf %{buildroot}

%target_setup
mkdir -p %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}

# Use install-no-fixedincludes, because we don't want any fixed headers, and
# because it creates syslimits.h as a side-effect.
cmd=`echo "%{target_makeinstall}" | sed 's/install$/install-no-fixedincludes/'`
eval $cmd \
	SYSTEM_HEADER_DIR=%{_mvl_cross_target_dir}/%{_mvl_target_include_dir} \
	libexecdir=%{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir} \
	2>&1

%demangle_libtool

gzip -v9 %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/gcov.1
gzip -v9 %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/gcc.1
gzip -v9 %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/cpp.1

# Put libgcc_s in the right place.
mkdir -p %{buildroot}%{_mvl_cross_target_dir}/%{_mvl_target_lib}
mv %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libgcc_s.so.1 \
	%{buildroot}%{_mvl_cross_target_dir}/%{_mvl_target_lib}/libgcc_s.so.1
# Make libgcc_s.so.1 executable so its debug information can be stripped by rpm.
chmod u+x %{buildroot}%{_mvl_cross_target_dir}/%{_mvl_target_lib}/libgcc_s.so.1

# The wildcard is because sonames for multilib'd libgccs may have a
# different name (for instance, libgcc_s_64.so).
mv %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libgcc_s*.so \
	%{buildroot}%{_mvl_cross_target_dir}/%{_mvl_target_lib}/

# For -print-file-name=cpp
mkdir -p %{buildroot}%{_mvl_cross_target_dir}/%{_mvl_target_lib}
ln -s ../usr/bin/cpp %{buildroot}%{_mvl_cross_target_dir}/%{_mvl_target_lib}/cpp

# Setup "cc" symlink to gcc
ln -s gcc %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/cc
# Setup "c++" symlink to g++
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/c++
ln -s g++ %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/c++

gzip -v9 %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/g++.1
#gzip -v9 %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_info_dir}/*

pushd %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}
for i in cpp g++ gcc gcov ; do
  ln -s $i %{_mvl_target_toolprefix}$i
done
popd

# Remove some other files we don't ship.
rm -rf %{buildroot}%{_libgccdir}/install-tools
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/gccbug
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolconfig}-gcc
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolconfig}-gcc-%{version}
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolconfig}-c++
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolconfig}-g++
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libiberty.a
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_info_dir}/dir
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man7/fsf-funding.7
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man7/gfdl.7
rm -f %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man7/gpl.7

%if "%{_mvl_target_cpu_type}" == "ppc"
# Remove PPC EABI startup files.
rm -f %{buildroot}%{_libgccdir}/ecrt*
rm -f %{buildroot}%{_libgccdir}/ncrt*
%endif

%if "%{_mvl_target_cpu_type}" != "x86"
# Locale files don't work cross?
rm -rf %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_data_dir}/locale
%endif

%if "%{_mvl_pkg_suffix}" != ""
mkdir -p %{buildroot}%{_multilibgccdir}
mv %{buildroot}%{_libgccdir}/%{_mvl_multilib} \
	%{buildroot}%{_multilibgccdir}/%{_mvl_multilib}
%endif

%if "%{_mvl_target_cpu}" == "x86_64"
# The way upstream GCC handles multilibs doesn't work for us.  Fix up
# the specs file.
patch --no-backup-if-mismatch %{buildroot}%{_libgccdir}/specs \
        < %{SOURCE8}
%endif

%if "%{_mvl_target_cpu}" == "ppc64"
# The way upstream GCC handles multilibs doesn't work for us.  Fix up
# the specs file.
patch --no-backup-if-mismatch %{buildroot}%{_libgccdir}/specs \
        < %{SOURCE9}
%endif

%if "%{_mvl_target_cpu}" == "mips64"
# The way upstream GCC handles multilibs and -mabi-fake-default breaks
# two things:
#   - the natural ways for us to enable multilibs
#   - --with-abi.
# Fix up the specs file to repair the damage.
%if "%{_mvl_target_arch}" == "mips64_octeon_be"
patch --no-backup-if-mismatch %{buildroot}%{_libgccdir}/specs \
       < %{SOURCE22}
%else
%if "%{_mvl_target_endian}" == "little"
patch --no-backup-if-mismatch %{buildroot}%{_libgccdir}/specs \
	< %{SOURCE20}
%else
patch --no-backup-if-mismatch %{buildroot}%{_libgccdir}/specs \
	< %{SOURCE21}
%endif
%endif
%endif

%if "%{_mvl_pkg_suffix}" != ""
# clean up unpackaged files
rm -rf %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}		\
	   %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/gcc \
	   %{buildroot}%{_libgccdir}	\
	   %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_man_dir}	\
	   %{buildroot}%{_mvl_cross_target_dir}/%{_mvl_target_lib}/cpp \
	   %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/c++/%{version} \
		%{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_info_dir}	\
		%{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/%{_mvl_multilib}/libiberty.a


%endif

%if "%{supports_backcompat}" == "yes"
cp %{SOURCE2}  %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libstdc++.so.5.0.5
pushd %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/
ln -s libstdc++.so.5.0.5 libstdc++.so.5
popd
%endif



%clean
rm -rf %{buildroot}


%files -n gcc%{_mvl_pkg_suffix}
%defattr(-,root,root)
%if "%{_mvl_pkg_suffix}" != ""
%{_multilibgccdir}/%{_mvl_multilib}
%else
%doc COPYING COPYING.LIB ChangeLog gcc/cp/NEWS
%doc LICENSE
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/cc
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/cpp
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolprefix}cpp
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/gcc
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolprefix}gcc
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/gcov
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolprefix}gcov
%dir %{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/gcc
%dir %{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/gcc/%{_mvl_target_toolconfig}
%dir %{_libgccdir}
%{_libgccdir}/crt*
%if "%{NUMA_SUPPORT}" == "yes"
%{_libgccdir}/numa-note.o
%endif

%{_libgccdir}/cc1
%{_libgccdir}/collect2
%{_libgccdir}/include
%{_libgccdir}/libgcc.a
%{_libgccdir}/libgcc_eh.a
%{_libgccdir}/libgcov.a
%{_libgccdir}/specs
%doc %{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/cpp.1.gz
%doc %{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/gcc.1.gz
%doc %{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/gcov.1.gz
%{_mvl_cross_target_dir}/%{_mvl_target_lib}/cpp

%if "%{_mvl_target_cpu_type}" == "x86"
%{_mvl_cross_target_dir}%{_mvl_target_data_dir}/locale/*/LC_MESSAGES/gcc.mo
%endif
%endif

%if "%{_mvl_pkg_suffix}" == ""
%files -n gcc-doc
%defattr(-,root,root)
%doc LICENSE
%doc %{_mvl_cross_target_dir}%{_mvl_target_info_dir}/*.info

%files -n g++%{_mvl_pkg_suffix}
%defattr(-,root,root)
%doc LICENSE
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/c++
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/g++
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/%{_mvl_target_toolprefix}g++
%doc %{_mvl_cross_target_dir}%{_mvl_target_man_dir}/man1/g++.1.gz
%{_libgccdir}/cc1plus
%endif

%files -n libgcc1%{_mvl_pkg_suffix}
%defattr(-,root,root)
%doc LICENSE
%{_mvl_cross_target_dir}/%{_mvl_target_lib}/libgcc_s*.so
%{_mvl_cross_target_dir}/%{_mvl_target_lib}/libgcc_s.so.1


%files -n libstdc++6%{_mvl_pkg_suffix}
%defattr(-,root,root)
%doc libstdc++-v3/ChangeLog
%doc LICENSE
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libstdc++.so.6*
%if "%{_mvl_target_cpu_type}" == "x86"
%if "%{_mvl_uclibc}" == ""
%{_mvl_cross_target_dir}%{_mvl_target_data_dir}/locale/*/LC_MESSAGES/libstdc++.mo
%endif
%endif


%files -n libstdc++6-dev%{_mvl_pkg_suffix}
%defattr(-,root,root)
%doc libstdc++-v3/docs/html
%doc LICENSE
%if "%{_mvl_pkg_suffix}" == ""
%dir %{_mvl_cross_target_dir}%{_mvl_target_include_dir}/c++
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/c++/%{version}
%endif
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libstdc++.a
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libsupc++.a
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libstdc++.la
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libsupc++.la
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libstdc++.so


%if "%{supports_backcompat}" == "yes"
%files -n compat-libstdc++5%{_mvl_pkg_suffix}
%defattr(-,root,root)
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libstdc++.so.5*
%endif


%changelog
* Wed Sep 13 2006 Khem Raj <kraj@mvista.com>
- bug 19620: Remove .gmo files as they are generated at build time.
* Mon Sep 11 2006 Khem Raj <kraj@mvista.com>
- bug 19620: FSF patches backports from gcc-3_4-branch.
* Fri Sep  8 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- bug 19974: program compiled with profile sigsevs if GCOV_PREFIX is not set.
* Tue Sep  5 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- bug 18891: valid c code could not be linked after wrong optimization.
* Fri Sep  1 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- bug 19781: Enable cross-profiling support.
* Wed Aug 30 2006 Aman Wardak <awardak@mvista.com>
- bug 18891: valid c code could not be linked after wrong optimization.
* Sun Aug 20 2006 Khem Raj <kraj@mvista.com>
- bug 19448: COMDAT group support for Xtensa.
* Sat Aug 19 2006 Khem Raj <kraj@mvista.com>
- bug 19376: Add VR4133 restriction 15 support.
* Mon Aug 07 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- bug 16111: Prelink doesn't work.
* Mon Jul 17 2006 Khem Raj <kraj@mvista.com>
- Bug 19250: Don't define USE_PT_GNU_EH_FRAME for uclibc.
* Wed Jul 12 2006 Khem Raj <kraj@mvista.com>
- Bug 19106: Re-enable index macro patch.
* Mon Jul 10 2006 Khem Raj <kraj@mvista.com>
- Bug 19234: Fix the regression from inherited binding patch.
* Fri Jun 23 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- remove #18891, 19006 fixes.
* Wed Jun 21 2006 Khem Raj <kraj@mvista.com>
- Bug 19001: Fix profile code generation.
* Tue Jun 13 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Bug 19006: [arm] ICE while building db.
* Fri Jun  9 2006 Khem Raj <kraj@mvista.com>
- Bug 18971: Use gen_int_mode instead of GEN_INT.
* Thu Jun  8 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Bug 18891: valid c code could not be linked after wrong optimization.
* Tue May 23 2006 Nitin Gupta <ngupta@mvista.com>
- Bug 18555: Merging Cavium_foundation_two_branch in foundation_two.
* Thu May 19 2006 Qunying Pan <qpan@mvista.com>
- Bug 18100: Fix build failure.
* Thu May 18 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Bug 17720: Remove Intel xscale toolchain with VFP support.
* Tue May 16 2006 Khem Raj <khem@mvista.com>
- Fix 18100: Package libgcc correctly for multilib targets.
- remove empty g++ multilib package.
* Tue May 02 2006 Khem Raj <khem@mvista.com>
- Fix 18072: Correct output templates for arm_movdi_vfp.
* Tue May 02 2006 Khem Raj <khem@mvista.com>
- Fix 17007: Use pc-relative addressing in thumb PIC mode.
* Tue May 02 2006 Khem Raj <khem@mvista.com>
- Fix 18174: Make __aeabi_uidiv and __aeabi_idiv thumb interworkable.
* Mon Apr 17 2006 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Bug 17720: Intel xscale toolchain with VFP enabled.
* Tue Apr 11 2006 Qunying Pan <qpan@mvista.com>
- Fix 17746: Reverse ppc_9xx preload patch update.
* Mon Apr 10 2006 Khem Raj <khem@mvista.com>
- Fix 15568: Add a warning for incompatible ARM float ABI's.
* Sun Apr 09 2006 Khem Raj <khem@mvista.com>
- Fix 17403: Fix GCC ICE in thumb code.
* Thu Apr 06 2006 Khem Raj <khem@mvista.com>
- Fix 17817: Fix longcall pragma for ppc.
* Wed Apr 05 2006 Khem Raj <khem@mvista.com>
- Fix 17007: Remove unwanted thumb interwoking patches.
* Tue Mar 28 2006 Khem Raj <khem@mvista.com>
- Fix 17487: Fix ICE in gcc reload pass.
* Mon Mar 27 2006 Khem Raj <khem@mvista.com>
- Fix 17604: Fix the type punned warning in stdc++.
* Mon Mar 27 2006 Qunying Pan <qpan@mvista.com>
- Fix 15857: Fix libstdc++.so.5 softlink.
* Thu Mar 23 2006 Khem Raj <khem@mvista.com>
- Fix 17603: Remove xtensa overlays from host-tool-gcc spec file.
* Tue Mar 21 2006 Qunying Pan <qpan@mvista.com>
- Fix 15857: Provide libstdc++.so.5 for ppc_7xx.
* Mon Mar 20 2006 Qunying Pan <qpan@mvista.com>
- Fix 17422: Fix LINK_SPEC to use ld-uClibc.so.0 for arm-eabi-uclibc
* Mon Mar 20 2006 Khem Raj <kraj@mvista.com>
- Bug 17436: Update configs for Xtensa.
* Tue Mar 7 2006 Khem Raj <khem@mvista.com>
- Fix 16384: Fix the ARM gcc ICE in xorg-x11.
* Tue Feb 28 2006 Khem Raj <khem@mvista.com>
- Fix 17142: Remove the warning about punned pointers in libstdc++ string.h.
* Tue Feb 21 2006 Khem Raj <khem@mvista.com>
- Fix 17142: Backport the ppc_9xx preload patch as applied on FSF GCC.
* Mon Feb 06 2006 Qunying Pan <qpan@mvista.com>
- Fix 16991: Make libgcc_s.so.1 executable.
* Tue Jan 24 2006 Qunying Pan <qpan@mvista.com>
- Fix 16891: Remove libstdc++.so from libstdc++.la library name list.
* Wed Jan 18 2006 Khem Raj <khem@mvista.com>
- Fix 16373: Import libgcc patch for thumb from nslug.
* Thu Dec 29 2005 Qunying Pan <qpan@mvista.com>
- Fix 12929: Add ChangeLog.e500 for ppc_85xx_dpfp.
* Tue Dec 27 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 16298: Pass -meabi=gnu for apcs/atpcs.
* Tue Dec 27 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 16457: Fix the include directory for -nptl option in arm.
* Thu Dec 22 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 16346: Fix -static and -nptl option for ppc.
* Fri Dec 16 2005 Khem Raj <khem@mvista.com>
- Fix 16373: Fix sys_cacheflush syscall for thumb.
- Add support for --with-mode for ARM GCC.
* Wed Dec 08 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 15653: Fix ICE is host-tool gcc solaris build.
* Tue Nov 22 2005 Qunying Pan <qpan@mvista.com>
- Fix 13684: Remove lib/libstdc++.so from host-tool-libstdc++6-dev package.
* Tue Nov 15 2005 Nitin Gupta <ngupta@mvista.com>
- Bug 15423: removing disable cxa atexit flag while configuring uclibc.
* Fri Nov 11 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 15653: Fix ICE is host-tool gcc solaris build.
* Thu Nov 03 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Fix 15226: Adding 8548 cpu to gcc config. 
* Mon Oct 31 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Fix 15344: Enable gcc-spe-e500-support.patch.
* Mon Oct 31 2005 Nitin Gupta <ngupta@mvista.com>
- Bug 15543: div0 function could not be handled in Thumb mode.
* Fri Oct 28 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14658: Fix regression due to arm preindexed addressing patch.
* Sat Oct 22 2005 Khem Raj <kraj@mvista.com>
- Fix 15476: Fix GCC internal error when VFP is enabled.
* Fri Oct 21 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 15414: FSF gcc 3.4 regressions and fixes.
* Thu Oct 20 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14648: Use __aeabi_idiv and  __aeabi_uidiv.
* Tue Oct 18 2005 Khem Raj <kraj@mvista.com>
- Fix 15344: Enable softfp ABI for for VFP FPU targets.
- Fix 14988: Enable mising numa support.
- Call dmake macro for make.
* Thu Oct 13 2005 Khem Raj <kraj@mvista.com>
- Fix 15344: Disable gcc-spe-e500-support.patch for the moment.
* Wed Oct 12 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14740: Fix type checking for C++. 
* Fri Oct 07 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 15250: Fix type checking on COMPONENT_REF.
* Fri Oct 07 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Bug 12929: 85xx enhancement tracker bug
* Mon Oct 03 2005 Khem Raj <kraj@mvista.com>
- Fix 14270: Honor NM_FOR_TARGET and OBJDUMP_FOR_TARGET.
* Mon Oct 03 2005 Khem Raj <kraj@mvista.com>
- Fix 15195: Fix memory aliasing information in inline memcpy for ARM.
* Fri Sep 30 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Fix 10593 enable vector instructions for x86_64
* Fri Sep 30 2005 Khem Raj <kraj@mvista.com>
- Fix 14806: Fix ARM target options parsing for the options without '='
* Fri Sep 30 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 15162: FSF gcc 3.4 regressions and fixes.
* Thu Sep 29 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 15128: Fix segmentation fault with sh_sh4_le-g++.
* Wed Sep 28 2005 Khem Raj <kraj@mvista.com>
- Bug 13901: Update GCC config overlays for xtensa_be.
* Tue Sep 20 2005 Nitin Gupta <ngupta@mvista.com>
- Bug 14988: NUMA is not supported in uClibc.
* Mon Sep 19 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14823: FSF gcc 3.4 regressions and fixes.
* Fri Sep 16 2005 Nitin Gupta <ngupta@mvista.com>
- Bug 14942: Adding support for uclibc in Foundation two branch.
* Thu Sep 15 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14658: Disable arm pre-indexed addressing patch due to regressions.
* Wed Sep 14 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14857: Merge xtensa gcc patches.
* Thu Sep 08 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14773: ICE in change_address_1, at emit-rtl.c.
* Tue Sep 06 2005 Khem Raj <kraj@mvista.com>
- Fix 14649: copy TLS base into a pseudo to avoid corruption before use.
* Fri Sep 02 2005 Khem Raj <kraj@mvista.com>
- Fix 14658: Split absolute addresses to allow arm pre-indexed addressing.
* Fri Sep 02 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 13770: FSF bug fixes 20191, 21709, 19435.
* Thu Sep 01 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 13804: FSF 2286: rdbuf() reads incorrect number of bytes.
* Thu Sep 01 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14546: FSF gcc 3.4 regressions and bug fixes.
* Sun Aug 28 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Fix 14402: gprof - will not create gmon.out
* Wed Aug 10 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 13944: Add RTABI functions for gcc.
* Wed Aug 10 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14239: PR 22167 Fix strange optimization bug when using -Os.
* Fri Aug 05 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14157: PR 20187 Wrong code for ((unsigned char)(unsigned long long)((a?a:1)&(a*b)))?0:1).
* Fri Aug 05 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14156: PR21899 Enum definition accepts values to be overriden.
* Fri Aug 05 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 14154: PR 21873 Infinite warning loop on bad array initializer.
* Tue Jul 19 2005 Khem Raj <kraj@mvista.com>
- Bug 13716: PR 20611: Duplicate local symbols generated with -fPIC and -O3.
* Tue Jul 19 2005 Nitin Gupta <ngupta@mvista.com>
- Bug 13715: PR 20563 Infinite loop in diagnostic (and ice after error message).
* Mon Jul 11 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 13115: Fix clobbering in rtl-optimization.
* Mon Jul 11 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 13114: Fix ICE in zero length array.
* Thu Jun 23 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 13146: Fix em64t-gcc -print-search-dirs to shows only 64-bit.
* Thu Jun 16 2005 Grigory Tolstolytkin <gtolstolytkin@ru.mvista.com>
- Fix 11417: Fix "--with-gxx-include-dir" option.
* Fri May 27 2005 Nora Pan <qpan@mvista.com>
- Fix 12227: Fix the inherited binding.
* Thu May 26 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 11446: Fix issue in -nptl option for x86. 
* Tue May 24 2005 Nitin Gupta <ngupta@mvista.com>
- Fix 12372: Fix reload address for internal64* instruction
* Fri May 20 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 11168: EABI compliance in arm_v4t.  
* Fri May 20 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 8928: Fix -pipe option.  
* Fri May 20 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 11446: Adding -nptl option for MIPS. 
* Thu May 19 2005 Khem Raj <kraj@mvista.com>
- Fix 12018: Fix the unaligned offsets in thumb fp based backtracking
* Thu May 19 2005 Nitin Gupta <ngupta@mvista.com>
- Fix 12420: gcc is generating incorrect .la files
* Wed May 18 2005 Daniel Jacobowitz <dan@codesourcery.com>
- Bug 9819: MIPS64 NPTL support.
* Wed May 18 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Fix 11860 variable is not judged correctly
* Mon May 16 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Fix 12349: Add -iwithsysroot option. 
* Fri May 13 2005 Khem Raj <kraj@mvista.com>
- Fix 12186: Enable reworked ppc9xx-reload-fp-constants.patch
* Fri May 13 2005 Khem Raj <kraj@mvista.com>
- Fix 11846: Move setting the decl's alignment to before creating the RTL
* Fri May 13 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 11540 Disable unswitching if cond is in different basic block. 
* Thu May 12 2005 Khem Raj <kraj@mvista.com>
- Fix 12186: Disable ppc9xx-reload-fp-constants.patch
* Tue May 10 2005 Khem Raj <kraj@mvista.com>
- Fix 10163: Fix numa policy to use --with-numa-policy.
* Mon May 09 2005 Khem Raj <kraj@mvista.com>
- Fix 12186: Fix ICE caused by reload of a pseudo reg into FLOAT_REGS.
* Tue May 03 2005 Nitin Gupta <ngupta@mvista.com>
- Fix 12044: Fix multi lib for target gcc.
* Mon May 02 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 12031 Update ARM TLS mechanism for latest kernel changes. 
* Thu Apr 28 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 11847 Fix structure layout of packed char.
* Thu Apr 21 2005 Nitin Gupta <ngupta@mvista.com>
- Fix 11821: Cleanup files, which are unpackaged for alterrnate abi gcc.
* Wed Apr 20 2005 Nitin Gupta <ngupta@mvista.com>
- Fix 11821: Seprate objdirs for alternate abis.
* Wed Apr 20 2005 Nitin Gupta <ngupta@mvista.com>
- Fixing target gcc specs file for ppc 9xx.
* Tue Apr 12 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 11446 Added "-nptl" option for linking directly with NPTL libraries.
* Fri Apr  1 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Bug 10594 failed at the testcase 20020103-1.c
* Wed Mar 30 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 10723 generate isync before blrl instruction for ppc440. 
* Thu Mar 17 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Fix bug 9755 gcc: va-arg-25.c testcase when -Os given
* Thu Mar 17 2005 Dinar Temirbulatov <dtemirbulatov@ru.mvista.com>
- Fix for em64t-gcc -print-search-dirs prints wrong paths for 64-bit
* Mon Mar 14 2005 Nitin Gupta <ngupta@mvista.com>
- Removing alt spec files to select alternate ABIs.
* Thu Mar 10 2005 Khem Raj <kraj@mvista.com>
- Bug 10718 Fix for ICE in target gcc for iwmmxt target in expand_mult() 
* Thu Mar 10 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 10862 Wrong assembly code is generated with -pg and -fPIC option. 
* Tue Mar 8 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 10226 FP register value save code is created by -O1 option. 
* Fri Mar 04 2005 Nitin Gupta <ngupta@mvista.com>
- First pass of removing alt spec files to select alternate ABIs.
* Tue Mar 01 2005 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 10214 Incorrect argument passing between reg and stack.
* Fri Feb 25 2005 Khem Raj <kraj@mvista.com>
- Fix bug 10163 enable NUMA support in gcc.
* Thu Feb 24 2005 Nitin Gupta <ngupta@mvista.com>
- Merging f2_64bit_branch to HEAD. Includes patches from humboldt_mips64
branch.
* Fri Feb 18 2005 Khem Raj <kraj@mvista.com>
- Fix bug 9849 frame pointer is generator when -pg is used in ARM gcc.
* Fri Feb 11 2005 Nora Pan <qpan@mvista.com>
- Fix bug 5750: Eliminate memory access between ll/sc pair in mips.
* Fri Jan 28 2005 Khem Raj <kraj@mvista.com>
- Fix bug 10018: The patch fixes the check for attributes of enumeral types
* Tue Jan 25 2005 Khem Raj <kraj@mvista.com>
- Fix bug 9855: The patch fixes the rpath search for MIPS gcc
* Sun Jan 23 2005 Khem Raj <kraj@mvista.com>
- Fix bug 9937: The patch fixes the wrong addressing mode generation for wldr/wstr instructions
* Fri Jan 21 2005 Khem Raj <kraj@mvista.com>
- Fix bug 8954: Removed %{_hhl_target_toolconfig}-gcc-%{version} from all versions of spec.in files.
* Thu Jan 20 2005 Khem Raj <kraj@mvista.com>
- Fix bug 9848: internal crash in xscale_le compiler,remove iwmmxt_DTOR patch.
* Thu Jan 14 2005 Khem Raj <kraj@mvista.com>
- Fix bug 9767: remove  --with-abi=aapcs switch .in files.
* Thu Jan 14 2005 Khem Raj <kraj@mvista.com>
- Fix bug 9767: Revert back the --with-abi=aapcs switch .in files.
* Thu Jan 13 2005 Khem Raj <kraj@mvista.com>
- Fix bug 9767: Revert the --with-abi=iwmmxt conditional from all .in files.
* Thu Jan 13 2005 Nora Pan <qpan@mvista.com>
- Fix bug 9714: Add MIPS NPTL support.
* Tue Jan 11 2005 Mark Hatle <mhatle@mvista.com>
- Fix host-tools-gcc.spec.in (now builds)
* Mon Jan 03 2005 Daniel Jacobowitz <dan@codesourcery.com>
- Merge ARM EABI support.
* Wed Dec 22 2004 Nitin Gupta <ngupta@mvista.com>
- Gcc upgrade from 3.4.2 to 3.4.3.
* Fri Dec 17 2004 Joe Green <jgreen@mvista.com>
- Replace _hhl_target_gcc_config with _mvl_target_gcc_config to fix build.
* Thu Dec 16 2004 Joe Green <jgreen@mvista.com>
- Remove BuildRequires statements.
* Wed Dec 15 2004 Nitin Gupta <ngupta@mvista.com>
- Separate package for libgcc
* Tue Dec 07 2004 Daniel Jacobowitz <dan@codesourcery.com>
- Merge current ARM patches.
* Mon Nov 29 2004 Joe Green <jgreen@mvista.com>
- Merge ARM TLS support.
* Sun Nov 28 2004 Gilbert Coville <gilbert@mvista.com>
- Contact MontaVista text added to bug report requests
* Fri Nov 19 2004 Joe Green <jgreen@mvista.com>
- Don't install files into libexec directory.
- Remove uclibc support.
- Additional installed file list cleanup.
* Tue Nov 16 2004 Joe Green <jgreen@mvista.com>
- Fix target library dependency problem that is affecting rpm 4.3.
- Remove or package unpackaged files in the buildroot.
* Tue Nov 09 2004 Joe Green <jgreen@mvista.com>
- Use host autoconf package; remove configure patch.
* Sun Nov 07 2004 Joe Green <jgreen@mvista.com>
- Remove PML files.
* Sun Nov 07 2004 Nora Pan <qpan@mvista.com>
- Bug 8823: Specify --with-abi=iwmmxt for iwmmxt.
* Fri Oct 29 2004 Joe Green <jgreen@mvista.com>
- Remove prep and build macros in comments to enable rpm 4.3.
* Thu Oct 28 2004 Nora Pan <qpan@mvista.com>
- Bug 8823: Remove absoleted ARM_FLAG_APCS_32 & ARM_FLAG_MMU_TRAPS options.
* Tue Oct 26 2004 Nora Pan <qpan@mvista.com>
- Fix bug 8823: Define __buildin_expect for gcc < 2.96
* Fri Oct 22 2004 Nora Pan <qpan@mvista.com>
- Add arm_v6_fp_le.
* Wed Oct 13 2004 Daniel Jacobowitz <dan@codesourcery.com>
- Disable -m64 for PowerPC SPE.
* Tue Oct 12 2004 Daniel Jacobowitz <dan@codesourcery.com>
- Fixes for PowerPC SPE extensions.
* Wed Oct 06 2004 Joe Green <jgreen@mvista.com>
- Merge up to gcc 3.4.2 complete.
- Add "--build" spec for configure to help correctly identify cross compiler.
* Thu Sep 23 2004 Nora Pan <qpan@mvista.com>
- Fix 8437 - remove --with-sysroot from target_tool_configure in gcc.spec.in
* Fri Sep 03 2004 Peter Rehley <prehley@mvista.com>
- Added missing files (caused errors on cygwin).  Remove tee
* Wed Aug 25 2004 Ranjani Cudavalli <rcudavalli@mvista.com>
- Bug 7398 libgcov.a is not linked with gcc.
* Mon Aug 02 2004 Joe Green <jgreen@mvista.com>
- Upgrade to released 3.4.1.
* Tue Jun 22 2004 Michael Eager <eager@mvista.com>
- Upgrade to gcc-3.4.1 prerelease snapshot.
* Thu Jun 3 2004 Michael Eager <eager@mvista.com>
- Fix PPC 85xx description.
- Temporarily force ppc-603 to not generate FP instructions.
* Tue Apr 27 2004 Michael Eager <eager@mvista.com>
- Update to gcc-3.4.0 release.
- Regenerate configure patch, remove invocation of autoconf, etc.
* Thu Feb 5 2004 Michael Eager <eager@mvista.com>
- First gcc-3.4 version.
